{ pkgs ? import <nixpkgs> {}}:
let rust-toolchain = with pkgs; symlinkJoin {
    name = "rust-toolchain";
    paths = [
      rustc
      cargo
      rustfmt
      rust-analyzer
      clippy
      rustPlatform.rustcSrc
    ];
  };
in pkgs.mkShell {
  RUST_SRC_PATH = "${pkgs.rust.packages.stable.rustPlatform.rustLibSrc}";
  buildInputs = [rust-toolchain];
  RUST_BACKTRACE = 1;
}
