#[macro_use]
use serde::{Serialize, Deserialize};

// How many lines are there from HIGHEST to LOWEST
pub const HEIGHT: usize = 32;
// "Pixels" from left to right
pub const WIDTH: usize = 32;
#[derive(Serialize, Deserialize, Debug,PartialEq)]
pub enum SemLine{
    SlowPicture(SemLinePhoto),
    FastPicture(SemLinePhoto),
    Camera(SemLinePhoto)

}
#[derive(Serialize, Deserialize, Debug,PartialEq)]
pub struct SemLinePhoto{
    line: u32,
    pixels:[u8;WIDTH]

}

#[cfg(test)]
mod tests {
    use super::*;
    use serde_json;
    #[test]
    fn test_serialize(){
        let test_struct: SemLine = SemLine::SlowPicture(SemLinePhoto{line:0,pixels:[0;WIDTH]});
        let serialized = serde_json::to_string(&test_struct).unwrap();
        let deserialized:SemLine = serde_json::from_str(&serialized).unwrap();
        assert_eq!(test_struct,deserialized);

    }
}
